package pgview;


import javax.swing.JFrame;
import java.awt.GridLayout;
import java.awt.BorderLayout;
import java.awt.FlowLayout;
import javax.swing.JButton;
import javax.swing.JPanel;
import javax.swing.JTextField;
import javax.swing.JLabel;
import javax.swing.JToggleButton;
import javax.swing.JTextArea;
import javax.swing.JCheckBox;
import javax.swing.JScrollPane;
import javax.swing.UIManager;
import javax.swing.SwingUtilities;
import java.awt.event.ActionEvent;
import javax.swing.event.ChangeListener;
import javax.swing.event.ChangeEvent;
import java.awt.Font;


public class PGView extends JFrame implements ChangeListener{

    /**
	 * 
	 */
	private static final long serialVersionUID = -2876348298874546544L;
	/**
     * {@.ja fobOpC}
     * {@.en main for debug}
     */
    public static void main(String[] args){
        PGView view = new PGView();
        view.init();
    }
    
    /**
     * {@.ja RXgN^}
     * {@.en Constructor}
     * 
     */
    public PGView(){
    	getContentPane().setLayout(new GridLayout(3, 1));


    	m_cb_a.addChangeListener(this);
    	m_cb_b.addChangeListener(this);
    	m_tb_ss.addChangeListener(this);
//    	m_bStart.addActionListener(this);
//    	m_bStop.addActionListener(this);

    	m_scrollpane = new JScrollPane(m_ta_messge); 

    	m_tb_ss.setFont(new Font("", Font.BOLD, 30));
    	m_a_frequency.setFont(new Font("", Font.BOLD, 20));
    	m_b_frequency.setFont(new Font("", Font.BOLD, 20));
    	m_tb_a_dir.setFont(new Font("", Font.BOLD, 20));
    	m_tb_b_dir.setFont(new Font("", Font.BOLD, 20));
    	
    	m_p1.setLayout(new FlowLayout());
    	m_p2.setLayout(new BorderLayout());
    	m_p3.setLayout(new BorderLayout());
    	m_p1.add(m_cb_a);
    	m_p1.add(m_l_a_dir);
    	m_p1.add(m_tb_a_dir);
    	m_p1.add(m_a_frequency);
    	m_p1.add(m_l_a_hz);
    	m_p1.add(m_cb_b);
    	m_p1.add(m_l_b_dir);
    	m_p1.add(m_tb_b_dir);
    	m_p1.add(m_b_frequency);
    	m_p1.add(m_l_b_hz);
    	m_p2.add(m_tb_ss);
//    	m_p3.add(m_ta_messge,BorderLayout.CENTER);
    	m_p3.add(m_scrollpane,BorderLayout.CENTER);
    	
    	getContentPane().add(m_p1);
    	getContentPane().add(m_p2);
    	getContentPane().add(m_p3);
    	
    }
    
    /**
     * {@.ja }
     * {@.en Initial}
     * 
     */
	public void init() {
		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		setTitle("PG Out");
    	setSize(260,300);
    	setResizable(false);
    	setVisible(true);
	}
	
    /**
     * {@.ja }
     * {@.en }
     * 
     */
	public boolean isStarting() {
		return m_tb_ss.isSelected();
	}
    /**
     * {@.ja }
     * {@.en }
     * 
     */
	public long getFrequencyA() {
		if(m_cb_a.isSelected()){
	        String str = m_a_frequency.getText();
			long fre =  Long.parseLong(str);
			return fre;
		}
		else{
			return 0;
		}
	}
    /**
     * {@.ja }
     * {@.en }
     * 
     */
	public long getFrequencyB() {
		if(m_cb_a.isSelected()){
	        String str = m_b_frequency.getText();
			long fre =  Long.parseLong(str);
			return fre;
		}
		else{
			return 0;
		}
	}

	/**
     * {@.ja ʍXV}
     * {@.en uodate}
     * 
     */
    public void stateChanged(ChangeEvent e) {
		String str = e.toString();
		Object obj = e.getSource();
		if(obj==(Object)m_cb_a) {
			JCheckBox cb = (JCheckBox)obj; 
		    if (cb.isSelected()) {
		    	m_tb_a_dir.setEnabled(true);
		    	m_a_frequency.setEnabled(true);
		    } else {
		    	m_tb_a_dir.setEnabled(false);
		    	m_a_frequency.setEnabled(false);
		    }
		}
		if(obj==(Object)m_cb_b) {
			JCheckBox cb = (JCheckBox)obj; 
		    if (cb.isSelected()) {
		    	m_tb_b_dir.setEnabled(true);
		    	m_b_frequency.setEnabled(true);
		    } else {
		    	m_tb_b_dir.setEnabled(false);
		    	m_b_frequency.setEnabled(false);
		    }
		}
		if(obj==(Object)m_tb_ss) {
			JToggleButton tb = (JToggleButton)obj; 
		    if (tb.isSelected()) {
		    	tb.setText("STOP");
		    	m_tb_a_dir.setEnabled(false);
		    	m_a_frequency.setEnabled(false);
		    	m_tb_b_dir.setEnabled(false);
		    	m_b_frequency.setEnabled(false);
		    	m_cb_a.setEnabled(false);
		    	m_cb_b.setEnabled(false);
		    } else {
		    	tb.setText("START");
		    	m_tb_a_dir.setEnabled(true);
		    	m_a_frequency.setEnabled(true);
		    	m_tb_b_dir.setEnabled(true);
		    	m_b_frequency.setEnabled(true);
		    	m_cb_a.setEnabled(true);
		    	m_cb_b.setEnabled(true);
		    }
		}
	}
    public void actionPerformed(ActionEvent e) {
        String lookAndFeel = "";
//        lookAndFeel = "com.sun.java.swing.plaf.motif.MotifLookAndFeel";
        lookAndFeel = "com.sun.java.swing.plaf.windows.WindowsLookAndFeel";
		try {
			UIManager.setLookAndFeel(lookAndFeel);
			SwingUtilities.updateComponentTreeUI(this);
		} catch (Exception ex) {
			ex.printStackTrace();
		}
    	
    }
    protected JPanel m_p1 = new JPanel();
    protected JPanel m_p2 = new JPanel(); 
    protected JPanel m_p3 = new JPanel(); 
    protected JToggleButton m_tb_ss = new JToggleButton("START");
    protected JButton m_bStart = new JButton("Start");
    protected JButton m_bStop = new JButton("Stop");
    protected JTextField m_a_frequency = new JTextField("1000", 4);
    protected JTextField m_b_frequency = new JTextField("1000", 4);
    protected JLabel m_l_a_hz = new JLabel("Hz");
    protected JLabel m_l_b_hz = new JLabel("Hz");
    protected JLabel m_l_a_dir = new JLabel("direction:");
    protected JLabel m_l_b_dir = new JLabel("direction:");
    protected JToggleButton m_tb_a_dir = new JToggleButton("+");
    protected JToggleButton m_tb_b_dir = new JToggleButton("+");
    protected JTextArea m_ta_messge = new JTextArea("message", 4, 15);
    protected JCheckBox m_cb_a = new JCheckBox("A:",true);
    protected JCheckBox m_cb_b = new JCheckBox("B:",true);
    protected JScrollPane m_scrollpane; 
}
